#include "scanner.h"


int main(int argc, char *argv[])
{

	welcome();

	argument_t *argument = NULL;
	argument = malloc(sizeof(argument_t));


	if ( argument == NULL ) {
		fprintf(stderr, "malloc argument failed\n");
		return EXIT_FAILURE;
	}


	if ( check_argument(argc, argv, argument) == -1 ) {
		argument_free(argument);
		return EXIT_FAILURE;
	}


	printf("** configure successfull .\n");
	

	if ( scan(argument) == -1 ) {
		argument_free(argument);
		fprintf(stderr, "!! Crash\n");
		return -1;
	}


	argument_free(argument);
	return EXIT_SUCCESS;
}


/* function */
int
scan(argument_t *argument)
{

	int ip_find = 0;
	int i, j;
	void *ret;
	sigset_t mask;
	pthread_t threads[argument->nbr_thread];
	argument_thread_t *arg[argument->nbr_thread];



	if ( sigaddset(&mask, SIGPIPE) == -1 ) {
		fprintf(stderr, "Build new mask faild\n");
		return -1;
	}


	if ( pthread_sigmask(SIG_SETMASK, &mask, NULL) == -1 ) {
		fprintf(stderr, "Assigned new signal mask failed\n");
		return -1;
	}

	printf("** Start scan ... CTRL+C for stop .\n\n");


	while ( strcmp(argument->ip_start, argument->ip_end) )  {

		j = 0;

		/* start thread */
		for ( i = 0; i < argument->nbr_thread; i++ ) {


			arg[i] = malloc(sizeof(argument_thread_t));	

			strcpy(arg[i]->ip, argument->ip_start);
			arg[i]->timeout = argument->timeout;


			if ( pthread_create(&threads[i], NULL, fn_scan_ip, arg[i]) == -1 ) {
				fprintf(stderr, "error create thread\n");
				return -1;
			}
			j++;


			if ( !strcmp(argument->ip_start, argument->ip_end) )
				break;


			if ( incremente_ip(argument->ip_start) == -1 ) {
				fprintf(stderr, "incremente ip failed\n");
				return -1;
			}


		}


		/* wait finish thread */
		for ( i = 0; i < j; i++ ) {

			pthread_join(threads[i], &ret);

			if ( ret == 0 ) {
				printf("to IP : %s -> Null session accept\n", arg[i]->ip);
				ip_find++;
				if ( argument->log )
					write_result_in_file(arg[i]->ip);

			}


			else if ( (int)ret == -2 ) {

				if ( argument->verbose )
					printf("to IP : %s  -> Port Open\n", arg[i]->ip);

			}


			free(arg[i]);
			arg[i] = NULL;
		}


	}


	printf("\n\n** Scan finish\n");
	printf("** Numbers IP find : %d\n\n", ip_find);


	return 0;
}



void*
fn_scan_ip(void *argument_thread)
{
	int ret;
	buff_t *buff;
	buff = argument_thread;


	signal(SIGPIPE, SIG_IGN);

	socket_client_t *client = malloc(sizeof(client));

	if ( client == NULL )
		pthread_exit((void *) -1);


	if ( socket_client_new(client, buff->ip) == -1 ) {
		socket_client_free(client);
		pthread_exit((void *) -1);
	}


	if ( socket_client_connect(client, buff->timeout) == -1 ) {
		socket_client_free(client);
		pthread_exit((void *) -1);
	}


	if ( test_anonymous_access(client, buff->timeout) == -1 ) {
		socket_client_free(client);
		pthread_exit((void *) -2);
	}


	socket_client_free(client);

	pthread_exit((void *) 0);
}



int
test_anonymous_access(socket_client_t *client, time_t timeout)
{

	char buffer[3000];

	if ( socket_client_send(client, USER) == -1 )
		return 1;

	sleep(2);

	if ( socket_client_send(client, PASS) == -1 )
		return -1;


	if ( socket_client_recv(client, buffer, timeout) == -1 )
		return -1;


	if ( check_succefull(buffer) == -1 )
		return -1;


	return 0;
}



int
check_succefull(char *ident_recv)
{
	char *search = NULL;

	search = strtok(ident_recv, "-");

	while ( search != NULL ) {

		if ( strstr(search, "230") != NULL )
			return 0;

		search = strtok(NULL, "\n");

	}

	return -1;
}



int
incremente_ip(char *ip)
{
	int i = 0;
	int tab_ip[4] = {0};
	char *buff = NULL;
	char *copy = NULL;


	copy = strdup(ip);
	if ( copy == NULL ) {
		fprintf(stderr, "erreur stdup copy\n");
		return -1;
	}

	buff = strtok(copy, ".");
	while ( buff != NULL ) {

		tab_ip[i] = atoi(buff);
		buff = strtok(NULL, ".");

		i++;
	}


	if ( tab_ip[0] == 255 ) {
		free(copy);
		return 1;
	}

	if ( tab_ip[1] == 255 ) {
		tab_ip[0]++;
		tab_ip[1] = 0;
	}

	if ( tab_ip[2] == 255 ) {
		tab_ip[1]++;
		tab_ip[2] = 0;
	}

	if ( tab_ip[3] == 255 ) {
		tab_ip[2]++;
		tab_ip[3] = -1;
	}

	tab_ip[3]++;

	memset(ip, 0, sizeof(ip));

	sprintf(ip, "%d.%d.%d.%d", tab_ip[0], tab_ip[1], tab_ip[2], tab_ip[3]);

	free(copy);
	return 0;
}


void
write_result_in_file(const char *ip)
{

	FILE* file= NULL;

	file = fopen("scan.txt", "a");

	if ( file == NULL ) {

		fclose(file);

		file = fopen("scan.txt", "w");

		fprintf(file, "\n\t\tResult to scan\n\n");

	}


	fprintf(file, "IP : %s -> Accept null session\n", ip);

	fclose(file);

}

void
welcome(void)
{
	fprintf(stdout, "\n\t\t --- Scanner of anonymous session FTP ---\n\t\t Coded : simpp ( # Bad Digites Team # )\n");
	fprintf(stdout, "\t\t Read README.txt for more information\n\n");
	fprintf(stdout, "** Configure paramet's ...\n");
}


